#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf unzip60.tar.gz
    cd unzip60
    ed -s unix/Makefile >/dev/null <<EOF
/^linux:/
/-O3 /
s/-O3 /$CFLAGS -DNO_LCHMOD /
/^linux_noasm:/
/-O /
s/-O /$CFLAGS -DNO_LCHMOD /
w
q
EOF
    case "`uname -m`" in
    *86)
	make -f unix/Makefile linux
	;;
    *)
	make -f unix/Makefile linux_noasm
	;;
    esac
    strip -R .note -R .comment unzip
    mkdir -p ../unzip/bin
    cp unzip ../unzip/bin/
    cd ..
    rm -rf unzip60
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
